/**************************************************************************************
 * debug.hh
 * Copyright (c) 2003 Virtual Werder
 *
 * part of coach
 *
 * implements:
 *   some macros for debug output that can be removed from the
 *   code completely
 *
 * requires:
 *   <none>
 *
 * Created on: 05.05.2003 by pagra
 * Maintainer: pagra
 * Group:
 * Co-authors:
 *
 *************************************************************************************/

#ifndef DEBUG_HH
#define DEBUG_HH

 
#include <iostream>

using namespace std;

#include "debugforuser.hh"

#ifdef DEBUG_ON
  #define DUMPVAR(a)                     cout << #a << "=" << a << endl
  #define DEBUG1(a)                      cout << a << endl
  #define DEBUG2(a,b)                    cout << a << b << endl
  #define DEBUG3(a,b,c)                  cout << a << b << c << endl
  #define DEBUG4(a,b,c,d)                cout << a << b << c << d << endl
  #define DEBUG5(a,b,c,d,e)              cout << a << b << c << d << e << endl
  #define DEBUG6(a,b,c,d,e,f)            cout << a << b << c << d << e << f \
                                              << endl
  #define DEBUG7(a,b,c,d,e,f,g)          cout << a << b << c << d << e << f \
                                              << g << endl
  #define DEBUG8(a,b,c,d,e,f,g,h)        cout << a << b << c << d << e << f \
                                              << g << h << endl
  #define DEBUG9(a,b,c,d,e,f,g,h,i)      cout << a << b << c << d << e << f \
                                              << g << h << i << endl
  #define DUMPVAR_CERR(a)                cerr << #a << "=" << a << endl
  #define DEBUG1_CERR(a)                 cerr << a << endl
  #define DEBUG2_CERR(a,b)               cerr << a << b << endl
  #define DEBUG3_CERR(a,b,c)             cerr << a << b << c << endl
  #define DEBUG4_CERR(a,b,c,d)           cerr << a << b << c << d << endl
  #define DEBUG5_CERR(a,b,c,d,e)         cerr << a << b << c << d << e << endl
  #define DEBUG6_CERR(a,b,c,d,e,f)       cerr << a << b << c << d << e << f \
                                              << endl
  #define DEBUG7_CERR(a,b,c,d,e,f,g)     cerr << a << b << c << d << e << f \
                                              << g << endl
  #define DEBUG8_CERR(a,b,c,d,e,f,g,h)   cerr << a << b << c << d << e << f \
                                              << g << h << endl
  #define DEBUG9_CERR(a,b,c,d,e,f,g,h,i) cerr << a << b << c << d << e << f \
                                              << g << h << i << endl
#else // !DEBUG_ON
  #define DUMPVAR(a)                     ;
  #define DEBUG1(a)                      ;
  #define DEBUG2(a,b)                    ;
  #define DEBUG3(a,b,c)                  ;
  #define DEBUG4(a,b,c,d)                ;
  #define DEBUG5(a,b,c,d,e)              ;
  #define DEBUG6(a,b,c,d,e,f)            ;
  #define DEBUG7(a,b,c,d,e,f,g)          ;
  #define DEBUG8(a,b,c,d,e,f,g,h)        ;
  #define DEBUG9(a,b,c,d,e,f,g,h,i)      ;
  #define DUMPVAR_CERR(a)                ;
  #define DEBUG1_CERR(a)                 ;
  #define DEBUG2_CERR(a,b)               ;
  #define DEBUG3_CERR(a,b,c)             ;
  #define DEBUG4_CERR(a,b,c,d)           ;
  #define DEBUG5_CERR(a,b,c,d,e)         ;
  #define DEBUG6_CERR(a,b,c,d,e,f)       ;
  #define DEBUG7_CERR(a,b,c,d,e,f,g)     ;
  #define DEBUG8_CERR(a,b,c,d,e,f,g,h)   ;
  #define DEBUG9_CERR(a,b,c,d,e,f,g,h,i) ;
#endif // DEBUG_ON


#if defined (DEBUG_PARSER)
  #define DUMPVAR_PARSER(a)                     cout << #a << "=" << a << endl
  #define DEBUG1_PARSER(a)                      cout << a << endl
  #define DEBUG2_PARSER(a,b)                    cout << a << b << endl
  #define DEBUG3_PARSER(a,b,c)                  cout << a << b << c << endl
  #define DEBUG4_PARSER(a,b,c,d)                cout << a << b << c << d << endl
  #define DEBUG5_PARSER(a,b,c,d,e)              cout << a << b << c << d << e << endl
  #define DEBUG6_PARSER(a,b,c,d,e,f)            cout << a << b << c << d << e << f \
                                                     << endl
  #define DEBUG7_PARSER(a,b,c,d,e,f,g)          cout << a << b << c << d << e << f \
                                                     << g << endl
  #define DEBUG8_PARSER(a,b,c,d,e,f,g,h)        cout << a << b << c << d << e << f \
                                                     << g << h << endl
  #define DEBUG9_PARSER(a,b,c,d,e,f,g,h,i)      cout << a << b << c << d << e << f \
                                                     << g << h << i << endl
  #define DUMPVAR_CERR_PARSER(a)                cerr << #a << "=" << a << endl
  #define DEBUG1_CERR_PARSER(a)                 cerr << a << endl
  #define DEBUG2_CERR_PARSER(a,b)               cerr << a << b << endl
  #define DEBUG3_CERR_PARSER(a,b,c)             cerr << a << b << c << endl
  #define DEBUG4_CERR_PARSER(a,b,c,d)           cerr << a << b << c << d << endl
  #define DEBUG5_CERR_PARSER(a,b,c,d,e)         cerr << a << b << c << d << e << endl
  #define DEBUG6_CERR_PARSER(a,b,c,d,e,f)       cerr << a << b << c << d << e << f \
                                                     << endl
  #define DEBUG7_CERR_PARSER(a,b,c,d,e,f,g)     cerr << a << b << c << d << e << f \
                                                     << g << endl
  #define DEBUG8_CERR_PARSER(a,b,c,d,e,f,g,h)   cerr << a << b << c << d << e << f \
                                                     << g << h << endl
  #define DEBUG9_CERR_PARSER(a,b,c,d,e,f,g,h,i) cerr << a << b << c << d << e << f \
                                                     << g << h << i << endl
#else // !DEBUG_PARSER
  #define DUMPVAR_PARSER(a)                     ;
  #define DEBUG1_PARSER(a)                      ;
  #define DEBUG2_PARSER(a,b)                    ;
  #define DEBUG3_PARSER(a,b,c)                  ;
  #define DEBUG4_PARSER(a,b,c,d)                ;
  #define DEBUG5_PARSER(a,b,c,d,e)              ;
  #define DEBUG6_PARSER(a,b,c,d,e,f)            ;
  #define DEBUG7_PARSER(a,b,c,d,e,f,g)          ;
  #define DEBUG8_PARSER(a,b,c,d,e,f,g,h)        ;
  #define DEBUG9_PARSER(a,b,c,d,e,f,g,h,i)      ;
  #define DUMPVAR_CERR_PARSER(a)                ;
  #define DEBUG1_CERR_PARSER(a)                 ;
  #define DEBUG2_CERR_PARSER(a,b)               ;
  #define DEBUG3_CERR_PARSER(a,b,c)             ;
  #define DEBUG4_CERR_PARSER(a,b,c,d)           ;
  #define DEBUG5_CERR_PARSER(a,b,c,d,e)         ;
  #define DEBUG6_CERR_PARSER(a,b,c,d,e,f)       ;
  #define DEBUG7_CERR_PARSER(a,b,c,d,e,f,g)     ;
  #define DEBUG8_CERR_PARSER(a,b,c,d,e,f,g,h)   ;
  #define DEBUG9_CERR_PARSER(a,b,c,d,e,f,g,h,i) ;
#endif //DEBUG_PARSER


#if defined (DEBUG_JOSH)
  #define DUMPVAR_JOSH(a)                     cout << #a << "=" << a << endl
  #define DEBUG1_JOSH(a)                      cout << a << endl
  #define DEBUG2_JOSH(a,b)                    cout << a << b << endl
  #define DEBUG3_JOSH(a,b,c)                  cout << a << b << c << endl
  #define DEBUG4_JOSH(a,b,c,d)                cout << a << b << c << d << endl
  #define DEBUG5_JOSH(a,b,c,d,e)              cout << a << b << c << d << e << endl
  #define DEBUG6_JOSH(a,b,c,d,e,f)            cout << a << b << c << d << e << f \
                                                    << endl
  #define DEBUG7_JOSH(a,b,c,d,e,f,g)          cout << a << b << c << d << e << f \
                                                    << g << endl
  #define DEBUG8_JOSH(a,b,c,d,e,f,g,h)        cout << a << b << c << d << e << f \
                                                    << g << h << endl
  #define DEBUG9_JOSH(a,b,c,d,e,f,g,h,i)      cout << a << b << c << d << e << f \
                                                    << g << h << i << endl
  #define DUMPVAR_CERR_JOSH(a)                cerr << #a << "=" << a << endl
  #define DEBUG1_CERR_JOSH(a)                 cerr << a << endl
  #define DEBUG2_CERR_JOSH(a,b)               cerr << a << b << endl
  #define DEBUG3_CERR_JOSH(a,b,c)             cerr << a << b << c << endl
  #define DEBUG4_CERR_JOSH(a,b,c,d)           cerr << a << b << c << d << endl
  #define DEBUG5_CERR_JOSH(a,b,c,d,e)         cerr << a << b << c << d << e << endl
  #define DEBUG6_CERR_JOSH(a,b,c,d,e,f)       cerr << a << b << c << d << e << f \
                                                    << endl
  #define DEBUG7_CERR_JOSH(a,b,c,d,e,f,g)     cerr << a << b << c << d << e << f \
                                                    << g << endl
  #define DEBUG8_CERR_JOSH(a,b,c,d,e,f,g,h)   cerr << a << b << c << d << e << f \
                                                    << g << h << endl
  #define DEBUG9_CERR_JOSH(a,b,c,d,e,f,g,h,i) cerr << a << b << c << d << e << f \
                                                    << g << h << i << endl
#else // !DEBUG_FOR_JOSH
  #define DUMPVAR_JOSH(a)                     ;
  #define DEBUG1_JOSH(a)                      ;
  #define DEBUG2_JOSH(a,b)                    ;
  #define DEBUG3_JOSH(a,b,c)                  ;
  #define DEBUG4_JOSH(a,b,c,d)                ;
  #define DEBUG5_JOSH(a,b,c,d,e)              ;
  #define DEBUG6_JOSH(a,b,c,d,e,f)            ;
  #define DEBUG7_JOSH(a,b,c,d,e,f,g)          ;
  #define DEBUG8_JOSH(a,b,c,d,e,f,g,h)        ;
  #define DEBUG9_JOSH(a,b,c,d,e,f,g,h,i)      ;
  #define DUMPVAR_CERR_JOSH(a)                ;
  #define DEBUG1_CERR_JOSH(a)                 ;
  #define DEBUG2_CERR_JOSH(a,b)               ;
  #define DEBUG3_CERR_JOSH(a,b,c)             ;
  #define DEBUG4_CERR_JOSH(a,b,c,d)           ;
  #define DEBUG5_CERR_JOSH(a,b,c,d,e)         ;
  #define DEBUG6_CERR_JOSH(a,b,c,d,e,f)       ;
  #define DEBUG7_CERR_JOSH(a,b,c,d,e,f,g)     ;
  #define DEBUG8_CERR_JOSH(a,b,c,d,e,f,g,h)   ;
  #define DEBUG9_CERR_JOSH(a,b,c,d,e,f,g,h,i) ;
#endif //DEBUG_JOSH


#endif // DEBUG_HH
