#include <iostream>
#include <deque>
#include <string>
#include <map>

using std::cout;
using std::cerr;
using std::endl;
using std::ostream;

using std::string;

using std::deque;
using std::map;

/**
 @ingroup Main
 @brief class ConfFileData in group Main
*/
class ConfFileData
{
  public:
  static void addVariableLong  (const char *name, long        defaultvalue);
  static void addVariableDouble(const char *name, double      defaultvalue);
  static void addVariableString(const char *name, const char *defaultvalue);
  static void addComment       (const char *text);
  static void addEmpty         ();

  static void  dumpHeaderLines(ostream &out,
			       const char *datestr, const char *argv0);
  static void    dumpCodeLines(ostream &out,
			       const char *datestr, const char *argv0);
  static void dumpKeywordLines(ostream &out);
  static void    dumpRuleLines(ostream &out);
  static void dumpDefaultLines(ostream &out,
			       const char *datestr, const char *argv0);


  private:
  static void addHeaderLineLong   (const char *name);
  static void addHeaderLineDouble (const char *name);
  static void addHeaderLineString (const char *name);
  static void addHeaderLineComment(const char *text);
  static void addHeaderLineEmpty  ();

  static void addCodeLineLong   (const char *name, long        defaultvalue);
  static void addCodeLineDouble (const char *name, double      defaultvalue);
  static void addCodeLineString (const char *name, const char *defaultvalue);
  static void addCodeLineComment(const char *text);
  static void addCodeLineEmpty  ();

  static void addKeywordLineLong   (const char *name);
  static void addKeywordLineDouble (const char *name);
  static void addKeywordLineString (const char *name);
  static void addKeywordLineComment(const char *text);
  static void addKeywordLineEmpty  ();

  static void addRuleLineLong   (const char *name);
  static void addRuleLineDouble (const char *name);
  static void addRuleLineString (const char *name);
  static void addRuleLineComment(const char *text);
  static void addRuleLineEmpty  ();

  static void addDefaultLineLong  (const char *name, long        defaultvalue);
  static void addDefaultLineDouble(const char *name, double      defaultvalue);
  static void addDefaultLineString(const char *name, const char *defaultvalue);
  static void addDefaultLineComment(const char *text);
  static void addDefaultLineEmpty ();

  static deque<string> headerLines;
  static deque<string> codeLines;
  static deque<string> keywordLines;
  static deque<string> tokenLines;
  static deque<string> ruleLines;
  static deque<string> defaultLines;

  static map<string,string> vars;
};
