/******************************************************************************
 * Communicator.hh
 * Copyright (c) 2003 Virtual Werder
 *
 *
 * implements:
 *   class Coach
 *
 * requires:
 *
 *
 * Created on: 07.05.2003 by pagra
 * Maintainer: pagra
 * Group:
 * Co-authors:
 *****************************************************************************/

#ifndef COMMUNICATOR_HH
#define COMMUNICATOR_HH

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <stdio.h>

/** @defgroup Network Network Classes
 *  This group contains all network related classes
 *  @{
 */

 
/**
 Socket structure
 */
struct Socket {
  int socketFd;
  struct sockaddr_in serv_addr;
};

/**
 This class represents the communicator between the coach and the soccer server.
*/
class Communicator {
public:
  Communicator();
  ~Communicator();

  void openConnection( const char *serverHost, int serverPort, 
		       const char *teamname, float version,
		       char *buf );
  void closeConnection();
  bool sendMessage( const char *msg );
  bool waitForAndReadMessage( char *buf );

  
private:

  Socket m_socket;

  //  int socketFdIn;
  //int socketFdOut;
  
  // struct sockaddr_in their_addr;

};

/** @} */ // end of Network

#endif // COMMUNICATOR_HH
