/***********************************************************************
 * Formation.cc
 * Copyright (c) 2003 Virtual Werder
 *
 * implements:
 *   class Formation
 *
 * requires:
 *
 *
 * Created on: 19.09.2003 by harlekin
 * Maintainer: cniehaus, harlekin
 * Group:
 * Co-authors: cniehaus
 *
 * Changelog:
 *
 * $Id: Formation.cc,v 1.1 2004/05/13 16:54:46 aw Exp $
 *
 **********************************************************************/


#include "Formation.hh"
//#include "debug.hh"

Formation::Formation(int id, 
		     const int *b, 
		     const double *hpx,  
		     const double *hpy,  
		     const double *ipx,  
		     const double *ipy,  
		     const double *aX, 
		     const double *aY,  
		     const double *maxX, 
		     const double *minX, 
		     const bool *bB){
  for (int i = 0; i < 11; i++){
    behaviour[i]  = b[i];
    homePos[i]    = Vector2D(hpx[i], hpy[i]);
    //homePos[i]    = hp[i];
    initPos[i]    = Vector2D(ipx[i], ipy[i]);
    attrX[i]      = aX[i];
    attrY[i]      = aY[i];
    this->maxX[i] = maxX[i];
    this->minX[i] = minX[i];
    behindBall[i] = bB[i];
  }
  this->id = id;
}
