/***********************************************************************
 * Formations.hh
 * Copyright (c) 2003 Virtual Werder
 *
 * implements:
 *   class Formation
 *
 * requires:
 *
 *
 * Created on: 19.09.2003 by harlekin
 * Maintainer: cniehaus, harlekin
 * Group:
 * Co-authors: cniehaus
 *
 * Changelog:
 *
 * $Id: Formations.hh,v 1.1 2004/05/13 16:54:47 aw Exp $
 *
 **********************************************************************/

#ifndef FORMATIONS_HH
#define FORMATIONS_HH

#include "Geometry.hh"
#include "common.hh"
#include "Formation.hh"
#include "debug.hh"
#include <vector>

class Formations{
public:
  Formations();
  ~Formations(){};
  
  static Formation *getFormation(int id);
  static Formation *getCurrentFormation() { return currentFormation; }
  static void addFormation(Formation f){ 
    //DEBUG2_HARLEKIN("Formation added: ", f.getId());
    formations.push_back(f); 
  }
  static void setCurrentFormation(int id){ currentFormation = getFormation(id); }

  /* Reading formations from file */
  static bool readFormations( const char *strFile );
  static char gotoFirstNonSpace( char** strMsg );
  static int parseFirstInt( char** strMsg );
  static double parseFirstDouble( char** strMsg );

  /* Creating formations from scratch */
  static int createFormationFrom(int defender, int attacker);
  static void distributePlayers(Formation *f, int type, int amount, int start);


  static Formation *currentFormation; 
  static vector<Formation> formations;
};
#endif
