/******************************************************************************
 * WorldModelState.hh
 * Copyright (c) 2003 Virtual Werder
 *
 *
 * implements:
 *   class WorldModelState
 *
 * requires:
 *
 *
 * Created on: 21.01.2004 by aw
 * Maintainer: aw, mangels
 * Group:
 * Co-authors:
 *
 * $Id: WorldModelState.hh,v 1.1 2004/04/13 11:58:49 aw Exp $
 *****************************************************************************/


#ifndef WORLDMODELSTATE_HH
#define WORLDMODELSTATE_HH

#include <vector>
#include "Player.hh"
#include "Ball.hh"
#include "common.hh"

using namespace std;

/**
 This class represents the current state of the worldmodel. It's used to save the 
 state in a history located in the worldmodel. 
 @ingroup WorldModel
 @brief class WorldModelState in group WorldModel
 */
class WorldModelState {
public:
	/**
	 constructs a new WorldModelState
	*/
	WorldModelState();
	
	/**
	 destructor
	 @todo to be implemented
	*/
  ~WorldModelState();
	
	/**
	 prints the worldmodel member variables to stdout
	*/
	void printState();

	/**
	 all known players of my team
	*/
	vector<Player> myTeam;
	
	/**
   all known players of the other team
	*/
  vector<Player> otherTeam;
  
	/**
	 the cycle of this worldmodelstate
	*/
  int time;

  /**
     the playmode of this cycle
  */
  Playmode playmode;

	/**
	 the ball (position & velocity)
	*/
  Ball ball;
};

#endif // WORLDMODELSTATE_HH
